ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
Revision: 1.87
Committed: Tue Oct 5 23:25:25 2010 UTC (13 years, 7 months ago) by root
Branch: MAIN
Changes since 1.86: +14 -1 lines
Log Message:
slightly better

File Contents

# Content
1 #!@PERL@
2
3 #
4 # This file is part of Deliantra, the Roguelike Realtime MMORPG.
5 #
6 # Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7 #
8 # Deliantra is free software: you can redistribute it and/or modify it under
9 # the terms of the Affero GNU General Public License as published by the
10 # Free Software Foundation, either version 3 of the License, or (at your
11 # option) any later version.
12 #
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the Affero GNU General Public License
19 # and the GNU General Public License along with this program. If not, see
20 # <http://www.gnu.org/licenses/>.
21 #
22 # The authors can be reached via e-mail to <support@deliantra.net>
23 #
24
25 use common::sense;
26
27 my $prefix = "@prefix@";
28 my $exec_prefix = "@exec_prefix@";
29 my $datarootdir = "@datarootdir@";
30 my $DATADIR = "@datadir@/@PACKAGE@";
31
32 my $CONVERT = "@CONVERT@";
33 #my $IDENTIFY = "@IDENTIFY@";
34 my $OPTIPNG = "@OPTIPNG@";
35 my $RSYNC = "@RSYNC@";
36 my $PNGNQ = "@PNGNQ@";
37
38 use Getopt::Long;
39 use File::Temp;
40 use POSIX ();
41 use Carp;
42
43 use Coro::EV;
44 use AnyEvent;
45 use YAML::XS ();
46 use JSON::XS ();
47 use IO::AIO ();
48 use Digest::MD5 ();
49
50 use Coro 5.12;
51 use Coro::AIO;
52 use Coro::Util;
53 use Coro::Channel;
54 use Coro::Storable; $Storable::canonical = 1;
55
56 use Deliantra;
57
58 $SIG{QUIT} = sub { Carp::cluck "QUIT" };
59
60 sub usage {
61 warn <<EOF;
62 Usage: cfutil [-v] [-q] [--force] [--cache]
63 [--install-arch path]
64 [--install-maps maps]
65 [--print-statedir]
66 [--print-confdir]
67 [--print-datadir]
68 [--print-libdir]
69 [--print-bindir]
70 EOF
71 exit 1;
72 }
73
74 my $VERBOSE = 1;
75 my $CACHE = 0;
76 my $FORCE;
77 my $TMPDIR = "/tmp/cfutil$$~";
78 my $TMPFILE = "aaaa0";
79 my @COMMIT;
80
81 our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95 );
96
97 END { system "rm", "-rf", $TMPDIR }
98
99 my $s_INT = EV::signal INT => sub { exit 1 };
100 my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102 our %hash;
103
104 # here we could try to avoid collisions and reduce chksum size further
105 sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122 }
123
124 mkdir $TMPDIR, 0700
125 or die "$TMPDIR: $!";
126
127 sub fork_sub(&) {
128 my ($cb) = @_;
129
130 if (my $pid = fork) {
131 my $current = $Coro::current;
132 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
133 Coro::schedule;
134 } else {
135 eval { $cb->() };
136 POSIX::_exit 0 unless $@;
137 warn $@;
138 POSIX::_exit 1;
139 }
140 }
141
142 sub inst_maps($) {
143 my (undef, $path) = @_;
144
145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
146
147 if (!-f "$path/regions") {
148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
149 exit 1 unless $FORCE;
150 }
151
152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
159 }
160
161 sub autoglyph {
162 my ($stem, $face) = @_;
163
164 if ($stem =~ /^wall\/|Nimwall/) {
165 # warn $stem;
166 "+"
167 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
168 "."
169 } else {
170 substr $stem, 0, 1
171 }
172 }
173
174 {
175 our %ANIMINFO;
176 our %FACEINFO;
177 our %RESOURCE;
178 our @ARC;
179 our %ARC;
180 our $TRS;
181 our $NFILE;
182 our $PATH;
183
184 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
185
186 our $c_arc = new Coro::Channel;
187 our $c_trs = new Coro::Channel;
188 our $c_res = new Coro::Channel;
189
190 our @c_png;
191
192 sub commit_png($$$$) {
193 my ($stem, $name, $data, $T) = @_;
194
195 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
196 $FACEINFO{$name}{"data$T"} = $data;
197 }
198
199 sub process_png {
200 while (@c_png) {
201 my ($path, $delete) = @{pop @c_png};
202
203 my $png;
204 aio_lstat $path;
205 my ($size, $mtime) = (stat _)[7,9];
206
207 if (0 > aio_load $path, $png) {
208 warn "$path: $!, skipping.\n";
209 next;
210 }
211
212 my $stem = $path;
213 my $T;
214
215 if ($stem =~ s/\.32x32\.png~?$//) {
216 $T = 32;
217 } elsif ($stem =~ s/\.64x64\.png~?$//) {
218 $T = 64;
219 } else {
220 warn "$path: weird filename, skipping.\n";
221 next;
222 }
223
224 # quickly extract width and height of the (necessarily PNG) image
225 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
226 warn "$path: not a recognized png file, skipping.\n";
227 next;
228 }
229
230 my ($w, $h) = unpack "NN", $1;
231
232 if ($w < $T || $h < $T) {
233 warn "$path: too small ($w $h), skipping.\n";
234 next;
235 }
236
237 if ($w % $T || $h % $T) {
238 warn "$path: weird png size ($w $h), skipping.\n";
239 next;
240 }
241
242 (my $base = $stem) =~ s/^.*\///;
243
244 my $fi = $FACEINFO{$base};
245 unless ($fi) {
246 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
247 #next;
248 }
249
250 my $arc = $fi->{arc} || { };
251
252 unless ($path =~ /~$/) {
253 # possibly enlarge
254 if (0 > aio_stat "$stem.64x64.png") {
255 my $other = "$stem.64x64.png~";
256
257 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
258 fork_sub {
259 my $CROP;
260 my $SRC = "png:\Q$path\E";
261
262 my $is_floor = $arc->{is_floor};
263 my $is_wall = 0;
264
265 my ($wall_pfx, $wall_dir, $wall_sfx);
266
267 if (
268 !$is_floor
269 && !$arc->{alive}
270 && $arc->{move_block} eq "all"
271 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
272 ) {
273 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
274
275 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
276 $is_wall = 1;
277 }
278 }
279
280 if ($is_wall || $is_floor) {
281 # add a 4px border and add other images around it
282 $CROP = "-shave 8x8 +repage";
283
284 $w += 8;
285 $h += 8;
286
287 $SRC = "-size ${w}x${h} xc:transparent";
288 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
289
290 # 8 surrounding images
291 for (
292 # x y b r0 r1
293 [-1, -1, 0, 6],
294 [ 0, -1, 1, 10, 14],
295 [+1, -1, 0, 12],
296
297 [-1, 0, 8, 5, 7],
298 #
299 [+1, 0, 2, 5, 13],
300
301 [-1, +1, 0, 3],
302 [ 0, +1, 4, 10, 11],
303 [+1, +1, 0, 9],
304 ) {
305 my ($x, $y, $d, $r0, $r1) = @$_;
306
307 my $tile = $is_floor ? $path
308 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
309 : die;
310
311 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
312 "\Q$tile",
313 $x * ($w - 8) + 4,
314 $y * ($h - 8) + 4;
315 }
316 }
317
318 system "convert -depth 8 $SRC rgba:-"
319 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
320 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
321 and die "convert/cfhq2xa pipeline error: status $? ($!)";
322 system $OPTIPNG, "-i0", "-q", "$other~";
323 die "$other~ has zero size, aborting." unless -s "$other~";
324 rename "$other~", $other;
325 };
326 }
327
328 push @c_png, [$other, !$CACHE];
329 }
330
331 # possibly scale down
332 if (0 > aio_stat "$stem.32x32.png") {
333 my $other = "$stem.32x32.png~";
334
335 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
336 fork_sub {
337 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
338 system $OPTIPNG, "-i0", "-q", "$other~";
339
340 # reduce smoothfaces >10000 bytes
341 # obsolete, no longer required
342 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
343 my $ncolor = 256;
344 while () {
345 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
346 system $OPTIPNG, "-i0", "-q", "$other~~";
347 last if 10000 > -s "$other~~";
348 $ncolor = int $ncolor * 0.9;
349 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
350 }
351
352 printf "reduced %s from %d to %d bytes using %d colours.\n",
353 $other, -s "$other~", -s "$other~~", $ncolor
354 if $VERBOSE >= 2;
355 rename "$other~~", "$other~";
356 }
357
358 die "$other~ has zero size, aborting." unless -s "$other~";
359 rename "$other~", $other;
360 };
361 }
362
363 #warn "scaled down $path to $other\n";#d#
364 push @c_png, [$other, !$CACHE];
365 }
366 }
367
368 (my $face = $stem) =~ s/^.*\///;
369
370 # split all bigfaces, but avoid smoothfaces (*_S)
371 if (($w > $T || $h > $T) && $face !~ /_S\./) {
372 # split
373 my @tile;
374 for my $x (0 .. (int $w / $T) - 1) {
375 for my $y (0 .. (int $h / $T) - 1) {
376 my $file = "$path+$x+$y~";
377 aio_lstat $file;
378 push @tile, [$x, $y, $file, (stat _)[9]];
379 }
380 }
381
382 my $mtime = (lstat $path)[9];
383 my @todo = grep { $_->[3] <= $mtime } @tile;
384 if (@todo) {
385 fork_sub {
386 open my $convert, "|-", $CONVERT,
387 "png:-",
388 (map {
389 (
390 "(",
391 "+clone",
392 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
393 "+repage",
394 -quality => "00",
395 -write => "png32:$_->[2]~",
396 "+delete",
397 ")",
398 )
399 } @todo),
400 "null:";
401
402 binmode $convert;
403 print $convert $png;
404 close $convert;
405
406 # pass 2, optimise, and rename
407 for (@todo) {
408 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
409 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
410 rename "$_->[2]~", $_->[2];
411 }
412 };
413 }
414
415 for (@tile) {
416 my ($x, $y, $file) = @$_;
417 my $tile;
418
419 if (0 > aio_load $file, $tile) {
420 die "$path: unable to read tile +$x+$y, aborting.\n";
421 }
422 IO::AIO::aio_unlink $file unless $CACHE;
423 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
424 }
425 } else {
426 # use as-is (either small, use smooth)
427 commit_png $stem, $face, $png, $T;
428 }
429
430 aio_unlink $path if $delete;
431 }
432 }
433
434 sub process_arc {
435 while (my $job = $c_arc->get) {
436 my ($dir, $file) = @$job;
437
438 my $arc;
439 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
440
441 my $arc = read_arch "$dir/$file";
442 for my $o (values %$arc) {
443 push @ARC, $o;
444 for (my $m = $o; $m; $m = $m->{more}) {
445 $ARC{$m->{_name}} = $m;
446 }
447
448 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
449
450 my $visibility = delete $o->{visibility};
451 my $magicmap = delete $o->{magicmap};
452 my $glyph = delete $o->{glyph};
453
454 # find upper left corner :/
455 # omg, this is sooo broken
456 my ($dx, $dy);
457 for (my $o = $o; $o; $o = $o->{more}) {
458 $dx = $o->{x} if $o->{x} < $dx;
459 $dy = $o->{y} if $o->{y} < $dy;
460 }
461
462 for (my $o = $o; $o; $o = $o->{more}) {
463 my $x = $o->{x} - $dx;
464 my $y = $o->{y} - $dy;
465
466 my $ext = $x|$y ? "+$x+$y" : "";
467
468 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
469
470 $visibility = delete $o->{visibility} if exists $o->{visibility};
471 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
472 $glyph = delete $o->{glyph} if exists $o->{glyph};
473
474 my $anim = delete $o->{anim};
475
476 if ($anim) {
477 # possibly add $ext to the animation name to avoid
478 # the need to specify archnames for all parts
479 # of a multipart archetype.
480 $o->{animation} = "$o->{_name}";
481 my $facings = 1;
482 my @frames;
483
484 for (@$anim) {
485 if (/^facings\s+(\d+)/) {
486 $facings = $1*1;
487 } elsif (/^blank.x11$|^empty.x11$/) {
488 push @frames, $_;
489 } else {
490 push @frames, "$_$ext";
491 }
492 }
493
494 $ANIMINFO{$o->{animation}} = {
495 facings => $facings,
496 frames => \@frames,
497 };
498 }
499
500 for ($o->{face} || (), @{$anim || []}) {
501 next if /^facings\s/;
502
503 my $face = $_;
504 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
505
506 my $info = $FACEINFO{$face} ||= { };
507 $info->{arc} = $o;
508
509 next if $face =~ /^blank.x11$|^empty.x11$/;
510
511 $info->{visibility} = $visibility if defined $visibility;
512 $info->{magicmap} = $magicmap if defined $magicmap;
513 $info->{glyph} = $glyph if defined $glyph;
514 }
515
516 if (my $smooth = delete $o->{smoothface}) {
517 my %kv = split /\s+/, $smooth;
518 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
519 while (my ($face, $smooth) = each %kv) {
520 $FACEINFO{$smooth}{arc} = $o;
521
522 $FACEINFO{$face}{smooth} = $smooth;
523 $FACEINFO{$face}{smoothlevel} = $level;
524 }
525 }
526 }
527 }
528 }
529 }
530
531 sub process_trs {
532 while (my $job = $c_trs->get) {
533 my ($dir, $file) = @$job;
534 my $path = "$dir/$file";
535
536 my $trs;
537 if (0 > aio_load $path, $trs) {
538 warn "$path: $!, skipping.\n";
539 next;
540 }
541
542 $TRS .= $trs;
543 }
544 }
545
546 my %FILECACHE;
547
548 sub load_cached($;$) {
549 unless (exists $FILECACHE{$_[0]}) {
550 my $data;
551 if (0 < aio_load $_[0], $data) {
552 if ($_[1]) {
553 $data = eval { $_[1]->($data) };
554 warn "$_[0]: $@" if $@;
555 }
556 }
557
558 $FILECACHE{$_[0]} = $data;
559 }
560
561 $FILECACHE{$_[0]}
562 }
563
564 sub process_res {
565 while (my $job = $c_res->get) {
566 my ($dir, $file, $type) = @$job;
567
568 my $data;
569 aio_load "$dir/$file", $data;
570
571 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
572
573 utf8::decode $dir;
574 utf8::decode $file;
575
576 # a meta file for resources is now mandatory
577 unless (exists $meta->{$file}) {
578 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
579 next;
580 }
581
582 $meta = {
583 %{ $meta->{"" } || {} },
584 %{ $meta->{$file} || {} },
585 };
586
587 if ($meta->{license} =~ s/^#//) {
588 $meta->{license} = ({
589 "pd" => "Public Domain",
590 "gpl" => "GNU General Public License, version 3.0 or any later",
591 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
592 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
593 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
594 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
595 })->{$meta->{license}}
596 || warn "$dir/$file: license tag '$meta->{license}' not found.";
597 }
598
599 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
600 ($meta->{author} = $1) =~ s/_/ /g;
601 }
602
603 $file =~ s/\.res$//;
604 $file =~ s/\.(ogg|wav|jpg|png)$//;
605
606 substr $dir, 0, 1 + length $PATH, "";
607
608 if (my $filter = $meta->{cfutil_filter}) {
609 if ($filter eq "yaml2json") {
610 $data = JSON::XS::encode_json YAML::XS::Load $data;
611 } elsif ($filter eq "json2json") {
612 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
613 } elsif ($filter eq "perl2json") {
614 $data = eval $data; die if $@;
615 $data = JSON::XS::encode_json $data;
616 } else {
617 warn "$dir/$file: unknown filter $filter, skipping\n";
618 }
619 }
620
621 $RESOURCE{"$dir/$file"} = {
622 type => (exists $meta->{type} ? delete $meta->{type} : $type),
623 data => $data,
624 %$meta ? (meta => $meta) : (),
625 };
626 }
627 }
628
629 sub find_files;
630 sub find_files {
631 my ($path) = @_;
632
633 IO::AIO::aioreq_pri 4;
634 IO::AIO::aio_scandir $path, 4, sub {
635 my ($dirs, $nondirs) = @_;
636
637 find_files "$path/$_"
638 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
639
640 my $dir = $path;
641 substr $dir, 0, 1 + length $PATH, "";
642
643 for my $file (@$nondirs) {
644 if ($dir =~ /^music(?:\/|$)/) {
645 $c_res->put ([$path, $file, 3]) # FT_MUSIC
646 if $file =~ /\.(ogg)$/;
647
648 } elsif ($dir =~ /^sound(?:\/|$)/) {
649 $c_res->put ([$path, $file, 5]) # FT_SOUND
650 if $file =~ /\.(wav|ogg)$/;
651
652 } elsif ($dir =~ /^res(?:\/|$)/) {
653 if ($file =~ /\.(jpg|png)$/) {
654 $c_res->put ([$path, $file, 0]) # FT_FACE
655 } elsif ($file =~ /\.(res)$/) {
656 $c_res->put ([$path, $file, 6]) # FT_RSRC
657 } else {
658 $c_res->put ([$path, $file, undef]);
659 }
660
661 } elsif ($file =~ /\.png$/) {
662 push @c_png, ["$path/$file", 0];
663
664 } elsif ($file =~ /\.trs$/) {
665 $c_trs->put ([$path, $file]);
666
667 } elsif ($file =~ /\.arc$/) {
668 $c_arc->put ([$path, $file]);
669
670 } else {
671 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
672 }
673 }
674 };
675 }
676
677 sub generate_plurals {
678 # use Lingua::EN::Inflect ();
679 # Lingua::EN::Inflect::classical;
680 # Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
681 # Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
682 #
683 # for my $a (@ARC) {
684 # my $name = $a->{name} || $a->{_name};
685 #
686 # next unless $a->{name_pl};
687 # next if $a->{invisible};
688 # next if $a->{is_floor};
689 # next if $a->{no_pick};
690 #
691 # my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
692 # my $pl = $test =~ /^(?:eq|p:.)$/
693 # ? $name
694 # : Lingua::EN::Inflect::PL $name;
695 #
696 # if ($pl ne $a->{name_pl}) {
697 # warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
698 # }
699 # }
700 }
701
702 sub inst_arch($) {
703 my (undef, $path) = @_;
704
705 $PATH = $path;
706
707 print "\n",
708 "Installing '$path' to '$DATADIR'\n",
709 "\n",
710 "This can take a long time if you run this\n",
711 "for the first time or do not use --cache.\n",
712 "\n",
713 "Unless you run verbosely, all following warning\n",
714 "or error messages indicate serious problems.\n",
715 "\n";
716
717 if (!-d "$path/treasures") {
718 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
719 exit 1 unless $FORCE;
720 }
721
722 print "scanning files...\n" if $VERBOSE;
723
724 find_files $path;
725
726 my @a_arc = map +(async \&process_arc), 1..2;
727 my @a_res = map +(async \&process_res), 1..2;
728 my @a_trs = map +(async \&process_trs), 1..2;
729
730 IO::AIO::flush;
731
732 $c_res->shutdown;
733 $c_arc->shutdown;
734 $c_trs->shutdown;
735
736 print "start file scan, arc, res processing...\n" if $VERBOSE;
737
738 $_->join for @a_arc; # need to parse all archetypes before png processing
739
740 print "end arc, start png processing...\n" if $VERBOSE;
741
742 # eight png crunchers work fine for my 4x smp machine
743 my @a_png = map +(async \&process_png), 1..8;
744
745 $_->join for (@a_trs, @a_res, @a_png);
746
747 print "scanning done, processing results...\n" if $VERBOSE;
748 {
749 # remove path prefix from editor_folder
750 $_->{editor_folder} =~ /^\x00/
751 and substr $_->{editor_folder}, 0, 2 + length $path, ""
752 for values %ARC;
753
754 print "resolving inheritance tree...\n" if $VERBOSE;
755 # resolve inherit
756 while () {
757 my $progress;
758 my $loop;
759
760 for my $o (values %ARC) {
761 for my $other (split /,/, $o->{inherit}) {
762 if (my $s = $ARC{$other}) {
763 if ($s->{inherit}) {
764 $loop = $s;
765 } else {
766 delete $o->{inherit};
767 my %s = %$s;
768 delete @s{qw(_name more name name_pl)};
769 %$o = ( %s, %$o );
770 ++$progress;
771 }
772 } else {
773 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
774 delete $ARC{$o->{_name}};
775 }
776 }
777 }
778
779 unless ($progress) {
780 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
781 if $loop;
782
783 last;
784 }
785 }
786
787 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
788 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
789
790 print "generating plurals...\n" if $VERBOSE;
791 generate_plurals;
792
793 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
794 open my $fh, ">:utf8", "$DATADIR/archetypes~"
795 or die "$DATADIR/archetypes~: $!";
796 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
797 }
798
799 {
800 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
801 open my $fh, ">:utf8", "$DATADIR/treasures~"
802 or die "$DATADIR/treasures~: $!";
803 print $fh $TRS;
804 }
805
806 {
807 print "processing facedata...\n" if $VERBOSE;
808 while (my ($k, $v) = each %FACEINFO) {
809 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
810 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
811
812 make_hash $k, $v->{data32}, $v->{hash32};
813 make_hash $k, $v->{data64}, $v->{hash64};
814
815 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
816 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
817
818 my $stem = delete $v->{stem};
819 $v->{glyph} //= autoglyph $stem, $v;
820
821 if (my $magicmap = $v->{magicmap}) {
822 $magicmap =~ y/A-Z_\-/a-z/d;
823 $v->{magicmap} = $COLOR{$magicmap};
824 }
825
826 delete $v->{arc};
827 }
828
829 print "processing resources...\n" if $VERBOSE;
830 my $enc = JSON::XS->new->utf8->canonical->relaxed;
831 while (my ($k, $v) = each %RESOURCE) {
832
833 if ($v->{meta} && $v->{meta}{datadir}) {
834 delete $RESOURCE{$k};
835
836 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
837
838 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
839 open my $fh, ">:raw", "$DATADIR/$k~"
840 or die "$DATADIR/$k~: $!";
841 syswrite $fh, $v->{data};
842 push @COMMIT, $k;
843
844 } else {
845 if ($v->{type} & 1) {
846 # prepend meta info
847
848 my $meta = $enc->encode ({
849 name => $k,
850 %{ $v->{meta} || {} },
851 });
852
853 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
854 }
855
856 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
857 }
858 }
859
860 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
861 scalar keys %FACEINFO,
862 scalar keys %ANIMINFO,
863 scalar keys %RESOURCE
864 if $VERBOSE;
865
866 open my $fh, ">:perlio", "$DATADIR/facedata~"
867 or die "$DATADIR/facedata~: $!";
868
869 print $fh nfreeze {
870 version => 2,
871 faceinfo => \%FACEINFO,
872 animinfo => \%ANIMINFO,
873 resource => \%RESOURCE,
874 };
875
876 }
877
878 print "committing files...\n" if $VERBOSE;
879
880 for (qw(archetypes facedata treasures), @COMMIT) {
881 chmod 0644, "$DATADIR/$_~";
882 rename "$DATADIR/$_~", "$DATADIR/$_"
883 or die "$DATADIR/$_: $!";
884 }
885
886 print "archetype data installed successfully.\n";
887 }
888 }
889
890 Getopt::Long::Configure ("bundling", "no_ignore_case");
891 GetOptions (
892 "verbose|v:+" => \$VERBOSE,
893 "cache" => \$CACHE,
894 "quiet|q" => sub { $VERBOSE = 0 },
895 "force" => sub { $FORCE = 1 },
896 "install-arch=s" => \&inst_arch,
897 "install-maps=s" => \&inst_maps,
898 "print-statedir" => sub { print "@pkgstatedir@\n" },
899 "print-datadir" => sub { print "$DATADIR\n" },
900 "print-confdir" => sub { print "@pkgconfdir@\n" },
901 "print-libdir" => sub { print "@libdir@/@PACKAGE@\n" },
902 "print-bindir" => sub { print "@bindir@/@PACKAGE@\n" },
903 ) or usage;
904